#_____________________________________________________________________#
#                                                                     #
# ۡ SenseLibrary Ver 1.25 :                                        #
# Date Created: 02-05-2000                                            #
# Date Last Modified: 01-11-2000                                      #
# Email: kstech@krsense.com                                           #
# Homepage: http://krsense.com                                        #
#                                                                     #
# Copyright 2000 (c) KrSense All Rights Reserved.                     #
# Please read the README.txt file for full details on terms of use.   #
#                                                                     #
#                                                                     #
# ۡۡۡ                                                            #
#  ũƮ ø  ҽ                              #
#  Ǵ ̺귯 Դϴ.                          #
#  ũƮ 뿡  ̼ README.txt Ͽ                #
#  õǾ Ƿ ݵ о ֽñ ٶϴ.                 #
# մϴ.                                                         #
#_____________________________________________________________________#
#                                                                     #
sub read_parse {
    my(@pairs, @temp, @FileLine, @FilePath, @line);
    my($content, $num, $name, $value, $boundary, $cut, $line, $temp, $file, $FileLength, $FirstValue);

    if ($ENV{'REQUEST_METHOD'} eq "POST") {
      binmode STDIN;
      read(STDIN, $content, $ENV{'CONTENT_LENGTH'});
      if (!$ENV{'CONTENT_TYPE'} || ($ENV{'CONTENT_TYPE'} eq "application/x-www-form-urlencoded")) {
        @pairs = split(/&/, $content);
        for $num (0..$#pairs) {
          ($name, $value) = split(/=/, $pairs[$num], 2);
          $name =~ s/\+/ /g;
          $name =~ s/%([0-9|A-F]{2})/pack(C,hex($1))/eg;
          $value =~ s/\+/ /g;
          $value =~ s/%([0-9|A-F]{2})/pack(C,hex($1))/eg;
          $FIELD{$name} = $value;
        }
      } elsif ($ENV{'CONTENT_TYPE'} =~ m|^multipart/form-data|) {
        ($boundary = $ENV{'CONTENT_TYPE'}) =~ s/^.+boundary=(.*)$/$1/;
        @temp = split(/--$boundary/, $content);
        @temp = splice(@temp, 1, $#temp-1);
        for $num (0..$#temp) {
          ($cut, $line, $temp) = split(/\r\n/, $temp[$num], 3);
          if ($line =~ /filename=\"/) {
            @FileLine = split(/\"/, $line);
            @FilePath = split(/\\/, $FileLine[3]);
            if (@FileName > 0) {
              push(@FileName, "$FilePath[$#FilePath]");
            } else {
              $FileName[0] = "$FilePath[$#FilePath]";
            }
            ($cut, $cut, $file) = split(/\r\n/, $temp, 3);
            chop($file);
            chop($file);
            $FileLength = length($file);
            if (@FileSize > 0) {
              push(@FileSize, "$FileLength");
            } else {
              $FileSize[0] = "$FileLength";
            }
          }
          next if ($line =~ /filename=\"\"$/);
          @line = split(/;\s+/, $line);
          ($name = $line[1]) =~ s/^name="(.+)"$/$1/g;
          if ($#line > 1) {
            if ($temp =~ /^Content-Type:/) {
              ($cut, $cut, $value) = split(/\r\n/, $temp, 3);
            } else {
              ($cut, $value) = split(/\r\n/, $temp, 2);
            }
            $FIELD{$name} = $value;
          } else {
            ($cut, $value) = split(/\r\n/, $temp, 2);
            chop($value);
            chop($value);
            if ($FIELD{$name}) {
              if (@{$FIELD{$name}} <= 0) {
                $FirstValue = $FIELD{$name};
                undef $FIELD{$name};
                $FIELD{$name}[0] = $FirstValue;
              }
              push(@{$FIELD{$name}}, $value);
            } else {
              if ($value !~ /^\s*$/) {
                $FIELD{$name} = $value;
              }
            }
          }
        }
      } else {
        print "Invalid Content-Type!\n";
        exit(1);
      }
    } else {
      @pairs = split(/&/, $ENV{'QUERY_STRING'});
      for $num (0..$#pairs) {
        ($name, $value) = split(/=/, $pairs[$num], 2);
        $name =~ s/\+/ /g;
        $name =~ s/%([0-9|A-F]{2})/pack(C,hex($1))/eg;
        $value =~ s/\+/ /g;
        $value =~ s/%([0-9|A-F]{2})/pack(C,hex($1))/eg;
        $FIELD{$name} = $value;
      }
    }
}


sub read_cookie {
    my(@pairs);
    my($num, $name, $value);

    @pairs = split(/; /, $ENV{'HTTP_COOKIE'}); 
    for $num (0..$#pairs) {
      ($name, $value) = split(/=/, $pairs[$num]); 
      $COOKIE{$name} = $value; 
    }
}


sub file_lock {
    my($Piece) = @_;

    while ((-e "$Piece/lock.tmp") && (time <= ((stat("$Piece/lock.tmp"))[9] + 40))) {
      select(undef, undef, undef, 0.1);
    }
    open(LOCK, ">$Piece/lock.tmp");
    flock(LOCK, 2) if ($Use_Flock);
}


sub file_unlock {
    my($Piece) = @_;

    flock(LOCK, 8) if ($Use_Flock);
    close LOCK;
    unlink("$Piece/lock.tmp");
}


sub self_substr {
    my(@Pieces) = @_;

    if (length($Pieces[0]) > $Pieces[1]) {
      $MaxSubPiece = 0;
      while ($Pieces[1] > $MaxSubPiece) {
        if (substr($Pieces[0], $MaxSubPiece, 1) =~ /[\xA1-\xFE]/) {
          last if (($Pieces[1] - 1) <= $MaxSubPiece);
          $MaxSubPiece += 2;
        } else {
          $MaxSubPiece += 1;
        }
      }
      return substr($Pieces[0], 0, $MaxSubPiece) . "..";
    } else {
      return "$Pieces[0]";
    }
}


sub get_time {
    ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
    @Week = ("Ͽ", "", "ȭ", "", "", "ݿ", "");

    $year += 1900;
    $mon += 1;
    $mon = "0$mon" if ($mon < 10);
    $mday = "0$mday" if ($mday < 10);
    $Week = "$Week[$wday]";
    if ($hour < 12) {
      $TimeTrait = "";
    } else {
      $TimeTrait = "";
      if ($hour != 12) {
        $hour -= 12;
      }
    }
    $hour = "0$hour" if ($hour < 10);
    $min = "0$min" if ($min < 10);

    $Date = "$year.$mon.$mday";
    $CurrentTime = "$year.$mon.$mday($Week) $TimeTrait $hour:$min";
}


sub crypt_pass {
    my($Piece) = @_;

    @SaltSet = ('A'..'Z','a'..'z','0'..'9','.','/');
    $Salt = "$SaltSet[12]" . "$SaltSet[8]";
    $Pass = crypt($Piece, $Salt);
}


sub send_mail {
    my(@Pieces) = @_;

    if ($SendMailGroup) {
      if ($SendSeparatedGroup) {
        if (-e "$Pieces[0]/mailsubject.tmp") {
          if (!$MailContents) {
            open(TEMP, "$Pieces[0]/mailsubject.tmp");
            $MailSubject = <TEMP>;
            close TEMP;
            open(TEMP, "$Pieces[0]/mailcontents.tmp");
            while (<TEMP>) {
              $MailContents .= $_;
            }
            close TEMP;
          }
        } else {
          open (TEMP, ">$Pieces[0]/mailsubject.tmp");
          print TEMP "$MailSubject";
          close TEMP;
        }
        if ($Pieces[3]) {
          unlink("$Pieces[0]/mailsubject.tmp");
        }
      }
    }

    if ($Sever_OS) {
      if ($SendMailGroup) {
        if ($SendSeparatedGroup) {
          if ($Pieces[3]) {
            unlink("$Pieces[0]/mailcontents.tmp");
          } else {
            if (!(-e "$Pieces[0]/mailcontents.tmp")) {
              open (TEMP, ">$Pieces[0]/mailcontents.tmp");
              print TEMP "$MailContents\n";
              close TEMP;
            }
          }
        }
      }
      open (MAIL, "|$Mail_Program -t");
      print MAIL "To: $Pieces[2]\n";
      print MAIL "From: $Pieces[1]\n";
      print MAIL "Subject: $MailSubject\n";
      print MAIL "$MailContents\n";
      close MAIL;
    } else {
      if ($SendMailGroup) {
        if (!(-e "$Pieces[0]/mailcontents.tmp")) {
          open (TEMP, ">$Pieces[0]/mailcontents.tmp");
          print TEMP "$MailContents\n";
          close TEMP;
        }
        if (!$Commandline) {
          $Commandline = "$Mail_Program";
          $Commandline .= "mailcontents.tmp";
          $Commandline .= "-s \"$MailSubject\"";
          $Commandline .= "-t \"$Pieces[2]\"";
          $Commandline .= "-f \"$Pieces[1]\"";
        }
      } else {
        open (TEMP, ">$Pieces[0]");
        print TEMP "$MailContents\n";
        close TEMP;
        $Commandline = "$Mail_Program";
        $Commandline .= "$Pieces[0]";
        $Commandline .= "-s \"$MailSubject\"";
        $Commandline .= "-t \"$Pieces[2]\"";
        $Commandline .= "-f \"$Pieces[1]\"";
      }
      system($Commandline);
      if ($SendMailGroup) {
        if ($Pieces[3]) {
          unlink("$Pieces[0]/mailcontents.tmp");
        }
      } else {
        unlink("$Pieces[0]");
      }
    }
}


sub alert_msg {
    my($Piece) = @_;

    print "Content-Type: text/html\n\n";
    print "<html>\n";
    if ($_BoardBGTile =~ /^http:\/\/.+\..+/i) {
      print "<body background=$_BoardBGTile bgcolor=$_BoardBGColor text=$_BoardFontColor link=$_BoardLinkColor vlink=$_BoardVisitedColor alink=$_BoardActiveColor$Piece>\n";
    } else {
      print "<body background=$Icons_Dir_URL/$_BoardBGTile bgcolor=$_BoardBGColor text=$_BoardFontColor link=$_BoardLinkColor vlink=$_BoardVisitedColor alink=$_BoardActiveColor$Piece>\n";
    }
    print "<script language=\"JavaScript\">\n";
    print "<!-- \n";
    print "alert(\"$Piece\");\n";
    print "history.back();\n";
    print "//-->\n";
    print "</script>\n";
    print "</body>\n";
    print "</html>\n";
    exit;
}

1;
